#!/usr/bin/env python

import sys
from xmlrpclib import Server

lifenet = Server("http://localhost:%d" % 2224)

print "test"

root_graph = lifenet.lifenet_new()
lifenet.lifenet_load(root_graph, "lifenet-graph.lisp")

print "test"

# we'll use this data object to store the default state of LifeNet
default_data  = lifenet.lifenet_data_new(4)

# allocate two data objects with 4 time slices each
known_data    = lifenet.lifenet_data_new(4)
inferred_data = lifenet.lifenet_data_new(4)

print "test"

# infer the default_data state of lifenet with no specific known_data
lifenet.lifenet_infer(root_graph, known_data, default_data)

print "test"

result = lifenet.lifenet_data_add_slices(known_data, root_graph, """
  (0 ('buy a house' 1.0))
  (1 ('proud' 1.0) ('have money' 0.0))
  (2)
  (3)
""")
if result != 0:
    print "Error adding data to known_data."
    sys.exit(-1)

print ""
print "All of known_data:"
print lifenet.lifenet_data_get_contents(known_data)

print "test"

lifenet.lifenet_infer(root_graph, known_data, inferred_data)

print "test"

# substract default probability state from inferred state to get the inferred probable difference
lifenet.lifenet_data_subtract(inferred_data, default_data)

print "test"

print ""
print "Top 4 assertions per slice of inferred_data:"
# display 4 nodes with largest positive difference from default_data states
print lifenet.lifenet_data_get_top_n_contents(inferred_data, 4)

print "test"


