#ifndef LIFENET_EXPORTED_H
#define LIFENET_EXPORTED_H

#include <swig_export.h>

#ifdef SWIG
%module lifenet
//%import "swig_export.i"
%include "swig_export.h"
#endif // SWIG

EXPORT int  lifenet_new();
EXPORT void lifenet_load(int lifenet_id, char* filename);
EXPORT void lifenet_delete(int lifenet_id);
EXPORT void lifenet_infer(int lifenet_id, int known_data_id, int inferred_data_id);
EXPORT void lifenet_print(int lifenet_id);
EXPORT void lifenet_add_edge(int lifenet_id, char* tag0_str, char* tag1_str, int is_temporal,
			     real plausibility);
EXPORT int  lifenet_add_edges(int lifenet_id, char* edges);

EXPORT int  lifenet_data_new(int slice_num);
EXPORT void lifenet_data_delete(int data_id);
EXPORT int  lifenet_data_add_slices(int data_id, int lifenet_id, char* slices);
EXPORT void lifenet_data_print(int data_id);
EXPORT void lifenet_data_add_phrases(int lifenet_id, int data_id,
				     int state, int argc0, int* argc1, char*** argv);
EXPORT void lifenet_data_get_contents(int data_id,
				      int* out_argc0, int** out_argc1, char**** out_argv,
				      int* out_real_c0, int** out_real_c1,
				      real*** out_real_vector);
EXPORT void lifenet_data_get_top_n_contents(int data_id, int top_num,
					    int* out_argc0, int** out_argc1, char**** out_argv,
					    int* out_real_c0, int** out_real_c1,
					    real*** out_real_vector);
EXPORT void lifenet_data_subtract(int a_data_id, int b_data_id);
EXPORT void lifenet_data_copy(int a_data_id, int b_data_id);

#endif // LIFENET_EXPORTED_H
