﻿class Assert {
	
	var id:String;
	var assert:String;
	var depth;
	var x:Number;
	var y:Number;
	var mytextfield:String;
	var duptextfield:String;
	var t:TextFormat;
	var target:MovieClip;
	var duplicateclip:MovieClip;
	var containerName:String;
	var height:Number;
	var width:Number;
	var temp;
	var drag:Boolean;
//	var dragOrigin;
	
	// global var here for container_depth, increment every time an object is made,
	// then remove it as a parameter for Assert
	
	// Movie clip that will contain visual representation of the box.
	private var container_mc:MovieClip;
	
	function Assert (id:String, assert:String, 
					 target:MovieClip, depth:Number, x:Number, y:Number, drag:Boolean) {

		setID(id);
		setAssert(assert);
		//setDepth(depth);
		this.drag = drag;
		containerName = "boxcontainer" + id;
		depth = target.getNextHighestDepth();
		container_mc = target.createEmptyMovieClip(containerName, depth);
		setY(y);
		setX(x);
		mytextfield = "mytextfield";
		fillText();
		//container_mc._width = 150;
		container_mc._width = width;
		container_mc._height = height;
	}
	
	public function destroy() :Void {
		//trace('destroying self');
		container_mc["mytextfield"].removeTextField();
		container_mc.removeMovieClip();
	}

	public function setID (id:String) :Void {
		this.id = id;
	}

	public function getID () :String {
		return id;
	}
	
	public function setAssert (assert:String) :Void {
		this.assert = assert;
	}

	public function getAssert () :String {
		return assert;
	}

	public function setDepth (depth:Number) :Void {
		this.depth = depth;
	}

	public function getDepth () :Number {
		return depth;
	}
	
	public function getX () :Number {
 		return container_mc._x;
	}
	
	public function setX (x:Number) :Void {
	    container_mc._x = x;
	}

	public function getY () :Number {
		return container_mc._y;
	}

  	public function setY (y:Number) :Void {
		container_mc._y = y;
	}
  	
	//create textfield within movie clip 
	//note flash actually creates a separate movie clip that contains the text and attaches it to the target.
	public function fillText() {
		var metrics = _root.tf.getTextExtent(assert, _root.propWidth); // change to target.width or something
		height = metrics.textFieldHeight;
		width = metrics.textFieldWidth;
		container_mc.createTextField(mytextfield, 0, 0, 0, _root.propWidth, height);
		container_mc[mytextfield].border = false;
		container_mc[mytextfield].text = assert;
		if (this.drag) {
			container_mc[mytextfield].setTextFormat(_root.tfdrag);
		} else {
			container_mc[mytextfield].setTextFormat(_root.tf);
		}
		container_mc[mytextfield].multiline = true;
  		container_mc[mytextfield].wordWrap = true;
		container_mc.type = "textfield";
		container_mc.assertObj = this;
		container_mc.onPress = function() {
			this.savex = this._x;
			this.savey = this._y;
			var point = { x: this._parent._xmouse, y: this._parent._ymouse };
			var mcpoint = { x: this._x, y: this._y };
			point.x = point.x - mcpoint.x;
			point.y = point.y - mcpoint.y;
			var mousepoint = { x: this._xmouse, y: this._ymouse };
			this.localToGlobal(mousepoint);
			_root.addlist.globalToLocal(mousepoint);
			point.x = mousepoint.x - point.x;
			point.y = mousepoint.y - point.y;
			temp = new Assert(this.assertObj.id, this.assertObj.assert,
					   _root.addlist, _root.addlist.getNextHighestDepth(), point.x, point.y, true);
			temp.container_mc.startDrag(false);
			if (_root.addlistscroll.hitTest(_root._xmouse, _root._ymouse, true)) {
				this.dragOrigin = 'addlist';
			}
			else {
				this.dragOrigin = '';
			}
		}
		container_mc.onRelease = function() {
			temp.container_mc.stopDrag();
			temp.container_mc.removeMovieClip();
		}
		container_mc.onReleaseOutside = function() {
			temp.container_mc.stopDrag();
			if (_root.trash.hitTest( _root._xmouse, _root._ymouse, true)) {
				temp.container_mc.removeMovieClip();
				if (this.dragOrigin != 'addlist') {
					this.removeMovieClip();
					Assert.alignAll();
				}
			}
			else if (_root.addlistscroll.hitTest( _root._xmouse, _root._ymouse, true)) {
				temp.container_mc.removeMovieClip();
				ServerInterface.serverPropsSearchSend(this.assertObj.assert);
			}
			else if (_root.aftertrue.hitTest( _root._xmouse, _root._ymouse, true)) {
				var dup = false;
				var obj;
				var i;
				for (i in _root.aftertrue) {
					obj = _root.aftertrue[i];
					if (obj.type == 'textfield' and this.assertObj.id == obj.assertObj.id) {
						dup = true;
					}
				}
				if (not dup) {
					new Assert(this.assertObj.id,
							   this.assertObj.assert,
							   _root.aftertrue, _root.aftertrue.getNextHighestDepth(), 1, 1, false);
					Assert.alignAll();
					ServerInterface.serverUpdateSend();
				}
				temp.container_mc.removeMovieClip();
			}
			else if (_root.duringtrue.hitTest( _root._xmouse, _root._ymouse, true)) {
				var dup = false;
				var obj;
				var i;
				for (i in _root.duringtrue) {
					obj = _root.duringtrue[i];
					if (obj.type == 'textfield' and this.assertObj.id == obj.assertObj.id) {
						dup = true;
					}
				}
				if (not dup) {
					new Assert(this.assertObj.id,
							   this.assertObj.assert,
							   _root.duringtrue, _root.duringtrue.getNextHighestDepth(), 1, 1, false);
					Assert.alignAll();
					ServerInterface.serverUpdateSend();
				}
				temp.container_mc.removeMovieClip();
			}
			//else if (this.container_mc._droptarget == "/beforetrue") {
			else if (_root.beforetrue.hitTest( _root._xmouse, _root._ymouse, true)) {
				var dup = false;
				var obj;
				var i;
				for (i in _root.beforetrue) {
					obj = _root.beforetrue[i];
					if (obj.type == 'textfield' and this.assertObj.id == obj.assertObj.id) {
						dup = true;
					}
				}
				if (not dup) {
					new Assert(this.assertObj.id,
							   this.assertObj.assert,
							   _root.beforetrue, _root.beforetrue.getNextHighestDepth(), 1, 1, false);
					Assert.alignAll();
					ServerInterface.serverUpdateSend();
				}
				temp.container_mc.removeMovieClip();
			}
			else if (_root.afterfalse.hitTest( _root._xmouse, _root._ymouse, true)) {
				var dup = false;
				var obj;
				var i;
				for (i in _root.afterfalse) {
					obj = _root.afterfalse[i];
					if (obj.type == 'textfield' and this.assertObj.id == obj.assertObj.id) {
						dup = true;
					}
				}
				if (not dup) {
					new Assert(this.assertObj.id,
							   this.assertObj.assert,
							   _root.afterfalse, _root.afterfalse.getNextHighestDepth(), 1, 1, false);
					Assert.alignAll();
					ServerInterface.serverUpdateSend();
				}
				temp.container_mc.removeMovieClip();
			}
			else if (_root.duringfalse.hitTest( _root._xmouse, _root._ymouse, true)) {
				var dup = false;
				var obj;
				var i;
				for (i in _root.duringfalse) {
					obj = _root.duringfalse[i];
					if (obj.type == 'textfield' and this.assertObj.id == obj.assertObj.id) {
						dup = true;
					}
				}
				if (not dup) {
					new Assert(this.assertObj.id,
							   this.assertObj.assert,
							   _root.duringfalse, _root.duringfalse.getNextHighestDepth(), 1, 1, false);
					Assert.alignAll();
					ServerInterface.serverUpdateSend();
				}
				temp.container_mc.removeMovieClip();
			}
			else if (_root.beforefalse.hitTest( _root._xmouse, _root._ymouse, true)) {
				var dup = false;
				var obj;
				var i;
				for (i in _root.beforefalse) {
					obj = _root.beforefalse[i];
					if (obj.type == 'textfield' and this.assertObj.id == obj.assertObj.id) {
						dup = true;
					}
				}
				if (not dup) {
					new Assert(this.assertObj.id,
							   this.assertObj.assert,
							   _root.beforefalse, _root.beforefalse.getNextHighestDepth(), 1, 1, false);
					Assert.alignAll();
					ServerInterface.serverUpdateSend();
				}
				temp.container_mc.removeMovieClip();
			}
			else {
				this._x = this.savex;
				this._y = this.savey;
				//trace("not in target - put back in original position");
				temp.container_mc.removeMovieClip();
			}
		}
	}
	
	static function alignAll() {
		var y_pos, i, obj;
		y_pos = 5;
		for (i in _root.beforetrue) {
			obj = _root.beforetrue[i];
			if (obj.type == "textfield") {
				obj._x = 5;
				obj._y = y_pos;
				y_pos = y_pos + obj.assertObj.height + _root.vspacing;
			}
		}
		y_pos = 5;
		for (i in _root.duringtrue) {
			obj = _root.duringtrue[i];
			if (obj.type == "textfield") {
				obj._x = 5;
				obj._y = y_pos;
				y_pos = y_pos + obj.assertObj.height + _root.vspacing;
			}
		}
		y_pos = 5;
		for (i in _root.aftertrue) {
			obj = _root.aftertrue[i];
			if (obj.type == "textfield") {
				obj._x = 5;
				obj._y = y_pos;
				y_pos = y_pos + obj.assertObj.height + _root.vspacing;
			}
		}
		y_pos = 5;
		for (i in _root.afterfalse) {
			obj = _root.afterfalse[i];
			if (obj.type == "textfield") {
				obj._x = 5;
				obj._y = y_pos;
				y_pos = y_pos + obj.assertObj.height + _root.vspacing;
			}
		}
		y_pos = 5;
		for (i in _root.duringfalse) {
			obj = _root.duringfalse[i];
			if (obj.type == "textfield") {
				obj._x = 5;
				obj._y = y_pos;
				y_pos = y_pos + obj.assertObj.height + _root.vspacing;
			}
		}
		y_pos = 5;
		for (i in _root.beforefalse) {
			obj = _root.beforefalse[i];
			if (obj.type == "textfield") {
				obj._x = 5;
				obj._y = y_pos;
				y_pos = y_pos + obj.assertObj.height + _root.vspacing;
			}
		}
	}
	
	static function makeObjects(idNum, xmlNode, target, depth, myy) :Assert {
		var one:Assert=new Assert(idNum, xmlNode, target, depth, 10, myy);
		return one;
	}
	
	function makeResult() {
		trace ("in makeResult");
		var i, obj;
		for (i in _root.beforetrue) {
			obj = _root.beforetrue[i];
			if (obj.type == "textfield") {
				trace(obj);
				//trace (this.assertObj.assert);
			}
		}
	}
}

