﻿class ServerInterface {
	
	static var sendXML:XML;
	static var receiveXML:XML;
	static var sendURL:String;
	
	static var clicks = 0;
	
	//~~~~~~~~ poll all boxes and send message to server ~~~~~~~~

	static function serverUpdateSend() {
		var i, obj;
		var myString = "<op>";
		for (i in _root.beforetrue) {
			obj = _root.beforetrue[i];
			if (obj.type == 'textfield') {
				myString = myString+'<p id="'+obj.assertObj.id+'" time="0" truth="1" />';
			}
		}
		for (i in _root.beforefalse) {
			obj = _root.beforefalse[i];
			if (obj.type == 'textfield') {
				myString = myString+'<p id="'+obj.assertObj.id+'" time="0" truth="0" />';
			}
		}
		for (i in _root.duringtrue) {
			obj = _root.duringtrue[i];
			if (obj.type == 'textfield') {
				myString = myString+'<p id="'+obj.assertObj.id+'" time="1" truth="1" />';
			}
		}
		for (i in _root.duringfalse) {
			obj = _root.duringfalse[i];
			if (obj.type == 'textfield') {
				myString = myString+'<p id="'+obj.assertObj.id+'" time="1" truth="0" />';
			}
		}
		for (i in _root.aftertrue) {
			obj = _root.aftertrue[i];
			if (obj.type == 'textfield') {
				myString = myString+'<p id="'+obj.assertObj.id+'" time="2" truth="1" />';
			}
		}
		for (i in _root.afterfalse) {
			obj = _root.afterfalse[i];
			if (obj.type == 'textfield') {
				myString = myString+'<p id="'+obj.assertObj.id+'" time="2" truth="0" />';
			}
		}
		myString = myString+"</op>";
		sendXML = new XML('update='+escape(myString));
		receiveXML = new XML();
		sendURL = "http://"+_root.machine+"/lifenetupdate";
		sendXML.sendAndLoad(sendURL, receiveXML);
		receiveXML.onLoad = ServerInterface.serverUpdateReceive;
	}
	
	static function serverUpdateReceive() {
		var root = receiveXML.firstChild;
		var node = root.firstChild;
		var y_pos_1 = 1;
		var y_pos_2 = 1;
		var y_pos_3 = 1;
		_root.beforelistscroll.contentPath = "beforelistscrollmc";
		var beforelistscrollcontent = _root.beforelistscroll.content;
		_root.duringlistscroll.contentPath = "duringlistscrollmc";
		var duringlistscrollcontent = _root.duringlistscroll.content;
		_root.afterlistscroll.contentPath = "afterlistscrollmc";
		var afterlistscrollcontent = _root.afterlistscroll.content;
		while (node) {
			var id = Number(node.attributes.id);
			var time = Number(node.attributes.time);
			var truth = Number(node.attributes.truth);
			var prop = String(node.firstChild);
			node = node.nextSibling;
			if (time == 0 and truth == 1) {
				var depth = beforelistscrollcontent.getNextHighestDepth();
				var assertobj = Assert.makeObjects(String(id), prop, beforelistscrollcontent, depth, y_pos_1);
				y_pos_1 = y_pos_1 + assertobj.height + _root.vspacing;
			}
			else if (time == 1 and truth == 1) {
				var depth = duringlistscrollcontent.getNextHighestDepth();
				var assertobj = Assert.makeObjects(String(id), prop, duringlistscrollcontent, depth, y_pos_2);
				y_pos_2 = y_pos_2 + assertobj.height + _root.vspacing;
			}
			else if (time == 2 and truth == 1) {
				var depth = afterlistscrollcontent.getNextHighestDepth();
				var assertobj = Assert.makeObjects(String(id), prop, afterlistscrollcontent, depth, y_pos_3);
				y_pos_3 = y_pos_3 + assertobj.height + _root.vspacing;
			}
		}
	}
	
	//~~~~~~~~ get propositions from server ~~~~~~~~
	
	/*
	static function nextDepth(obj) {
	 	var t = -Infinity;
 		for (var i in obj) {
  			if(obj[i].getDepth() != null && obj[i]._parent == obj){
   				t = Math.max(t, obj[i].getDepth());
   			}
  		}
 		return (t > -1) ? ++t: 0;
	}
	*/
	
	static function serverPropsSearchReceive() {
		_root.addlistscroll.contentPath = "addlistscrollmc";
		var addlistscrollcontent = _root.addlistscroll.content;
		var depth;
		var x_pos = 1;
		var y_pos = 1;
		var root = receiveXML.firstChild;
		var node = root.firstChild;
		while (node) {
			var id = Number(node.attributes.id);
			var prop = String(node.firstChild);
			node = node.nextSibling;
			depth = addlistscrollcontent.getNextHighestDepth();
			var assertobj = Assert.makeObjects(String(id), prop, addlistscrollcontent, depth, y_pos);
			y_pos = y_pos + assertobj.height + 3;
		}
	}
	
	static function serverPropsSearchSend(query) {
		sendXML = new XML('query='+query);
		receiveXML = new XML();
		sendURL = "http://"+_root.machine+"/lifenetsearch";
		sendXML.sendAndLoad(sendURL, receiveXML);
		receiveXML.onLoad = ServerInterface.serverPropsSearchReceive;
	}
	
	static function eraseAsserts() {
		var obj, i;
		for (i in _root.beforetrue) {
			obj = _root.beforetrue[i];
			if (obj.type == 'textfield') {
				obj.assertObj.destroy();
			}
		}
		for (i in _root.duringtrue) {
			obj = _root.duringtrue[i];
			if (obj.type == 'textfield') {
				obj.assertObj.destroy();
			}
		}
		for (i in _root.aftertrue) {
			obj = _root.aftertrue[i];
			if (obj.type == 'textfield') {
				obj.assertObj.destroy();
			}
		}
	}
	
	static function serverGameReceive() {
		ServerInterface.eraseAsserts();
		var root = receiveXML.firstChild;
		var node = root.firstChild;
		var y_pos_1 = 1;
		var y_pos_2 = 1;
		var y_pos_3 = 1;
		var prop1;
		while (node) {
			var id = Number(node.attributes.id);
			var time = Number(node.attributes.time);
			var truth = Number(node.attributes.truth);
			var prop = String(node.firstChild);
			node = node.nextSibling;
			if (time == 0 and truth == 1) {
				var depth = _root.beforetrue.getNextHighestDepth();
				var assertobj = Assert.makeObjects(String(id), prop, _root.beforetrue, depth, y_pos_1);
				y_pos_1 = y_pos_1 + assertobj.height + _root.vspacing;
				prop1 = prop;
			}
			else if (time == 1 and truth == 1) {
				var depth = _root.duringtrue.getNextHighestDepth();
				var assertobj = Assert.makeObjects(String(id), prop, _root.duringtrue, depth, y_pos_2);
				y_pos_2 = y_pos_2 + assertobj.height + _root.vspacing;
			}
			else if (time == 2 and truth == 1) {
				var depth = _root.aftertrue.getNextHighestDepth();
				var assertobj = Assert.makeObjects(String(id), prop, _root.aftertrue, depth, y_pos_3);
				y_pos_3 = y_pos_3 + assertobj.height + _root.vspacing;
			}
		}
		Assert.alignAll();
		serverUpdateSend();
		//serverPropsSearchSend(prop1);
	}
	
	static function serverBeginGame(query) {
		sendXML = new XML("unique="+clicks);
		clicks = clicks + 1;
		receiveXML = new XML();
		sendURL = "http://"+_root.machine+"/lifenetbegin";
		sendXML.sendAndLoad(sendURL, receiveXML);
		receiveXML.onLoad = ServerInterface.serverGameReceive;
	}
}
