import MySQLdb, MySQLdb.cursors, re, types, string

connection = MySQLdb.connect(host='localhost', user='root', passwd='omsql', \
                             db='omlife', cursorclass=MySQLdb.cursors.DictCursor)
cursor = connection.cursor()

sits = {}

def store(str):
  str = string.replace(str, '\\', '\\\\')
  str = string.replace(str, "'", "\\'")
  return str

def insertRow(table, column_values):
  # insert a new row into TABLE, taking column values from the dict COLUMN_VALUES
  columns = ' ('
  values = ' ('
  for column_value in column_values.items():
    columns = columns + column_value[0] + ', '
    if type(column_value[1]) == types.IntType or type(column_value[1]) == types.FloatType:
      values = values + store(str(column_value[1])) + ', '
    else:
      values = values + "'" + store(str(column_value[1])) + "', "
  columns = columns[:-2] + ') '
  values = values[:-2] + ') '
  cursor.execute('insert into ' + table + columns + "values" + values)

print 'loading stopwords'

def getWords(filename):
  f = open(filename)
  wordlist = string.split(f.read())
  words = {}
  for word in wordlist:
    words[word] = 1
  f.close()
  return words

stopwords = getWords('../../natlang/data/stopwords.txt')

def is_stopword(w):
  return stopwords.has_key(w)

print 'loading dictionary'

extract = re.compile('^(\S*)\s*(\S*)\s*')  # extracts word and lexeme
lemmatised = {}
f = open('../../natlang/data/morph-truncated-fixed.txt')
while 1:
  line = f.readline()
  if line == '':
    break
  results = re.findall(extract, line)
  if results:
    result = results[0]
    lemmatised[result[0]] = result[1]
f.close()

def lemmatise(w):
  if lemmatised.has_key(w):
    return lemmatised[w]
  else:
    return w

f = open('lifenet-sits.lisp')

def simplify(s):
  s = string.strip(s)
  new = ""
  words_list = re.split("[\W]+", s)
  words_list = filter(lambda x: x != '' and not is_stopword(x), words_list)
  words_list = map(lambda x: lemmatise(string.lower(x)), words_list)
  for w in words_list:
    if new == "":
      new = w
    else:
      new = new + " " + w
  return new

pat = re.compile('\((.*) "(.*)"\)')

i = 1
while 1:
    line = f.readline()
    if line == '':
        break
    m = re.findall(pat, line)
    if m:
        m = m[0]
        id = int(m[0])
        sitText = m[1]
        simplified = simplify(sitText)
        insertRow('props', { 'id': id, 'textkeys': simplified, 'text': sitText })
        i = i + 1
        if i % 100 == 0:
          print i

f.close()

f = open('lifenet-graph.lisp')

pat = re.compile('\((.*) (.*) "(.*)" "(.*)" (.*) (.*)\)')

i = 1
while 1:
    line = f.readline()
    if line == '':
        break
    m = re.findall(pat, line)
    if m:
        m = m[0]
        linktype = m[0]
        prob = float(m[1])
        before = m[2]
        after = m[3]
        x = int(m[4])
        y = int(m[5])
        sits[x] = before
        sits[y] = after
        if linktype == '=>':
          insertRow('temporal', {'orig': x, 'dest': y, 'prob': prob })
        else:
          insertRow('atemporal', {'orig': x, 'dest': y, 'prob': prob })
        i = i + 1
        if i % 1000 == 0:
            print i

f.close()

