﻿import XMLRPC.*;

dynamic class LifeNet.Connection {
  
  public var conn;
  public var server:String;
  
  public function Connection(server:String) {
    this.server = server;
    conn = new XMLRPC.Connection(server, 20);
  }
  
  public function get_root_graph(on_load:Function) {
    conn = new XMLRPC.Connection(server, 20);
    conn.ClearParameters();
    conn.Call("get_root_graph");
    conn.OnLoad = on_load;
  }

  public function new_graph(on_load:Function) {
    conn = new XMLRPC.Connection(server, 20);
    conn.ClearParameters();
    conn.Call("new_graph");
    conn.OnLoad = on_load;
  }
  
  public function add_edge(on_load:Function,
                           lifenet_id:Number,
                           tag0:String,
                           tag1:String,
                           is_temporal:Number,
                           plausibility:Number) {
    conn = new XMLRPC.Connection(server, 20);
    conn.ClearParameters();
    conn.AddParameter("int",   lifenet_id); 
    conn.AddParameter("string",tag0); 
    conn.AddParameter("string",tag1); 
    conn.AddParameter("int",   is_temporal); 
    conn.AddParameter("double",plausibility); 
    conn.Call("add_edge");
    conn.OnLoad = on_load;
  }
  
  public function data_new(on_load:Function,
			   slice_num:Number) {
    conn = new XMLRPC.Connection(server, 20);
    conn.ClearParameters();
    conn.AddParameter("int", slice_num); 
    conn.Call("data_new");
    conn.OnLoad = on_load;
  }

  public function data_delete(on_load:Function,
			      data_id:Number) {
    conn = new XMLRPC.Connection(server, 20);
    conn.ClearParameters();
    conn.AddParameter("int", data_id); 
    conn.Call("data_delete");
    conn.OnLoad = on_load;
  }

  public function data_get_contents(on_load:Function,
			            data_id:Number) {
    conn = new XMLRPC.Connection(server, 20);
    conn.ClearParameters();
    conn.AddParameter("int", data_id); 
    conn.Call("data_get_contents");
    conn.OnLoad = on_load;
  }
  
  public function infer(on_load:Function,
		        graph_id:Number,
		        known_data_id:Number,
			inferred_data_id:Number) {    
    conn = new XMLRPC.Connection(server, 20);
    conn.ClearParameters();
    conn.AddParameter("int", graph_id); 
    conn.AddParameter("int", known_data_id); 
    conn.AddParameter("int", inferred_data_id); 
    conn.Call("infer");
    conn.OnLoad = on_load;
  }

  public function data_add_slices(on_load:Function,
				  data_id:Number,
				  graph_id:Number,
				  slices:String) {
    conn = new XMLRPC.Connection(server, 20);
    conn.ClearParameters();
    conn.AddParameter("int", data_id); 
    conn.AddParameter("int", graph_id); 
    conn.AddParameter("string", slices); 
    conn.Call("data_add_slices");
    conn.OnLoad = on_load;
  }

  public function data_get_top_n_contents(on_load:Function,
				          data_id:Number,
				          top_num_per_slice:Number) {
    conn = new XMLRPC.Connection(server, 20);
    conn.ClearParameters();
    conn.AddParameter("int", data_id); 
    conn.AddParameter("int", top_num_per_slice); 
    conn.Call("data_get_top_n_contents");
    conn.OnLoad = on_load;
  }

  public function add_edges(on_load:Function,
			    graph_id:Number,
			    edges_str:String) {
    conn = new XMLRPC.Connection(server, 20);
    conn.ClearParameters();
    conn.AddParameter("int", graph_id); 
    conn.AddParameter("string", edges_str); 
    conn.Call("add_edges");
    conn.OnLoad = on_load;    
  }

  public function data_subtract(on_load:Function,
				data_a_id:Number,
				data_b_id:Number) {
    conn = new XMLRPC.Connection(server, 20);
    conn.ClearParameters();
    conn.AddParameter("int", data_a_id); 
    conn.AddParameter("int", data_b_id); 
    conn.Call("data_subtract");
    conn.OnLoad = on_load;
  }

}

/*
    def get_root_graph(self):
        """ Returns the LifeNet root graph with all basic primary commonsense knowledge."""
        return root_graph
    
    def new_graph(self):
        """ Creates a new empty LifeNet MRF2 probabilistic graph structure."""
        return lifenet_new()
    
    def add_edge(self, lifenet_id, tag0, tag1, is_temporal, plausibility):
        """ Adds edge between two LifeNet nodes with specified
        plausibility, which is converted to a JPD."""
        lifenet_add_edge(lifenet_id, tag0, tag1, is_temporal, plausibility)
        return 1

    def add_edges(self, lifenet_id, links):
        """ Adds edges between LifeNet nodes with specified
        plausibilities, which are converted to JPDs."""
        return lifenet_add_edges(lifenet_id, links);
        
    def infer(self, lifenet_id, known_data_id, inferred_data_id):
	""" Performs belief propogating inference in order to get
	probabilities for unknown concept truth."""
	lifenet_infer(lifenet_id, known_data_id, inferred_data_id)
	return 1

    def data_new(self, slice_num):
	""" Creates a new Data object for LifeNet inference."""
	return lifenet_data_new(slice_num)

    def data_delete(self, data_id):
	""" Releases all resources associated with a Data object."""
	lifenet_data_delete(data_id)
	return 1

    def data_add_slices(self, data_id, lifenet_id, slices):
        """ Adds mutliple slice data matching a graph's nodes to a data object."""
        return lifenet_data_add_slices(data_id, lifenet_id, slices)

    def data_add_datum(self, data_id, lifenet_id, slice_index, tag, probability):
        """ Add single datum with probability to a data object."""
        return lifenet_data_add_slices(data_id, lifenet_id, "(%d (\"%s\" %g))" % (slice_index, tag, probability))

    def data_add_phrases(self, lifenet_id, data_id, truth_state, phrases):
	""" Add all phrase matches within LifeNet to a Data object."""
	lifenet_data_add_phrases(lifenet_id, data_id, truth_state, phrases)
	return 1

    def data_get_contents(self, data_id):
	""" Get the probabilistic contents of a Data object."""
	return lifenet_data_get_contents(data_id)

    def data_get_top_n_contents(self, data_id, top_num_per_slice):
	""" Get the probabilistic contents of a Data object."""
	return lifenet_data_get_top_n_contents(data_id, top_num_per_slice)

    def data_subtract(self, data_id, subtract_data_id):
	""" Subtract the probability contents of one Data object from another."""
	lifenet_data_subtract(data_id, subtract_data_id)
	return 1

    def data_copy(self, data_id, src_data_id):
	""" Copy the probability contents of one Data object to another."""
	lifenet_data_copy(data_id, src_data_id)
	return 1
*/

