﻿import LifeNet.Connection;
import Draw.Functions;

dynamic class LifeNet.Test {
  
  public var drawfunc;
  public var next_depth = 1;
  
  public var background;
  public var topmenu;
  public var statusbar;
  public var contents;
  public var slice_num;
  public var user_know;
  public var save_user_know;
  public var knowledge;
  public var inference;
  
  public var lifenet;
  public var root_graph;
  public var knowledge_data;
  public var inference_data;
  public var slices_str;
  
  public var performing_inference = false;
  public var need_inference = 0;
  
  public function create_rect(parent, varname:String, x:Number, y:Number, w:Number, h:Number, r:Number, fgcolor, bgcolor) {
    var rect        = parent.createEmptyMovieClip(varname, next_depth++);
    rect._x         = x;
    rect._y         = y;
    rect.width      = w;
    rect.height     = h;
    rect.lineStyle(1, fgcolor, 100); 
    rect.beginFill(bgcolor, 100);
    drawfunc.drawRect(rect, 0, 0, w, h, r);
    rect.endFill();
    return rect;
  }
  
  public function create_textfield(parent, varname:String, x:Number, y:Number, w:Number, h:Number, textcolor, textsize:Number, alignment:String) {
    parent.createTextField(varname, next_depth++, x, y, w, h);
    var button_text_format   = new TextFormat();
    button_text_format.font  = "arial";
    button_text_format.size  = textsize;
    button_text_format.color = textcolor;
    button_text_format.align = alignment;
    parent[varname].setNewTextFormat(button_text_format);
    parent[varname].embedFonts = true;
    return parent[varname];
  }
  
  public function create_textrect(parent, varname:String, x:Number, y:Number, w:Number, h:Number, r:Number, fgcolor, bgcolor,
                                  textcolor, fontsize:Number, alignment:String) {
    var rect = create_rect(parent, varname, x, y, w, h, r, fgcolor, bgcolor);
    create_textfield(rect, "textfield", 0, 0, w, h, textcolor, fontsize, alignment);
    return rect;
  }
  
  public function split_string(src:String, div:String) {
    var _result = new Array();
    var _d = src.length;
    var _n = 0;
    var _tmpStr = "";
    var _ch;
    while(_n<_d) {
      _ch = substring(src, ++_n, 1);
      if(_ch==div) {
        _result.push(_tmpStr);
        _tmpStr="";
      } else{
        _tmpStr += _ch;
      }
    }
    _result.push(_tmpStr);
    return _result;
  }
  
  public function perform_inference() {
                _root.test.set_status("Waiting for LifeNet server to delete inference data.");
                _root.test.lifenet.data_delete(function() {
                  _root.test.set_status("Waiting for LifeNet server to create new inference data.");
                  _root.test.lifenet.data_new(function(data_id){
                    _root.test.inference_data = data_id;
                    _root.test.set_status("Waiting for LifeNet server to perform inference over unknown knowledge.");
                    _root.test.lifenet.infer(function(){
 
                      _root.test.set_status("Waiting for LifeNet server to subtract default inference.");
                      _root.test.lifenet.data_subtract(function() {
                        _root.test.set_status("Waiting for LifeNet server to get inference data contents.");
                        _root.test.lifenet.data_get_top_n_contents(function(inference_data_contents) {
                          for(k_slice_index = 0; k_slice_index < inference_data_contents.length &&
                                                 k_slice_index < _root.test.slice_num; k_slice_index ++) {
                            _tmp_str = "";
                            for(contents_index = 0; contents_index < inference_data_contents[k_slice_index].length; contents_index ++) {
                              _tmp_str += inference_data_contents[k_slice_index][contents_index] + "\r";
                            }
                            _root.test.inference[k_slice_index].textfield.text = _tmp_str;
                            _tmp_str = "";
                            for(contents_index = 0; contents_index < inference_data_contents[k_slice_index].length; contents_index ++) {
                              _before_text_index = _tmp_str.length;
                              _tmp_str += inference_data_contents[k_slice_index][contents_index] + "\r";
                              _text_format = new TextFormat();
                              _intensity = Math.round(255*(1.0-2*inference_data_contents[_root.test.slice_num][k_slice_index][contents_index]));
                              if(_intensity < 0) {
                                _intensity = 0;
                              } else if(_intensity > 255) {
                                _intensity = 255;                            
                              }
                              _text_format.color = _intensity*256*256 + _intensity*256 + _intensity;
                              _root.test.inference[k_slice_index].textfield.setTextFormat(_before_text_index, _tmp_str.length,
                                                                                          _text_format);
                            }
                          }
                          _root.test.set_status("LifeNet Temporal Inference Ready.");
                          _root.test.performing_inference = false;
                          if(_root.test.need_inference > 0) {
                            _root.test.need_inference = 0;
                            _root.test.update_inference();
                          }
                        }, _root.test.inference_data, 10);
                      }, _root.test.inference_data, _root.test.default_data);
                    }, _root.test.root_graph, _root.test.knowledge_data, _root.test.inference_data);
                  }, _root.test.slice_num);
                }, _root.test.inference_data);
  }

  public function update_inference() {
    need_inference ++;
    if(performing_inference == false) {
      performing_inference = true;
      need_inference --;
      slices_str = "";
      for(update_index = 0; update_index < slice_num; update_index ++) {
        save_user_know[update_index] = user_know[update_index].textfield.text;
        user_know_array = split_string(user_know[update_index].textfield.text, "\r");
        user_know_array_count = 0;
        for(user_array_index = 0; user_array_index < user_know_array.length; user_array_index ++) {
          if(user_know_array[user_array_index] != "") {
            user_know_array_count ++;
          }
        }
        if(user_know_array_count > 0) {
          slices_str += "(" + update_index;
          for(user_array_index = 0; user_array_index < user_know_array.length; user_array_index ++) {
            if(user_know_array[user_array_index] != "") {
              slices_str += " (\"" + user_know_array[user_array_index] + "\" 1.0)";
            }
          }
          slices_str += ")";
        }
      }
      set_status("Waiting for LifeNet server to delete knowledge data.");
      lifenet.data_delete(function() {
        _root.test.set_status("Waiting for LifeNet server to create new knowledge data.");
        _root.test.lifenet.data_new(function(data_id){
          _root.test.knowledge_data = data_id;
          _root.test.set_status("Waiting for LifeNet server to add knowledge data slices.");
          _root.test.lifenet.data_add_slices(function(){
            _root.test.set_status("Waiting for LifeNet server to get knowledge data contents.");
            _root.test.lifenet.data_get_contents(function(knowledge_data_contents){
              for(k_slice_index = 0; k_slice_index < knowledge_data_contents.length &&
                                     k_slice_index < _root.test.slice_num; k_slice_index ++) {
                _tmp_str = "";
                for(contents_index = 0; contents_index < knowledge_data_contents[k_slice_index].length; contents_index ++) {
                  _tmp_str += knowledge_data_contents[k_slice_index][contents_index] + "\r";
                }
                _root.test.knowledge[k_slice_index].textfield.text = _tmp_str;
              }
              // shortcut the inference because it's too slow to call for every typed character
              if(_root.test.need_inference > 0) {
                _root.test.performing_inference = false;
                _root.test.need_inference = 0;
                _root.test.update_inference();
              } else {
                _root.test.set_status("LifeNet Temporal Inference Ready.");
                _root.test.performing_inference = false;
//                _root.test.perform_inference();
              }
            }, _root.test.knowledge_data);
          }, _root.test.knowledge_data, _root.test.root_graph, _root.test.slices_str);
        }, _root.test.slice_num);
      }, knowledge_data);
    }
  }
  
  public function create_contents_rect() {
    contents = create_rect(_root, "contents", background._x + 5, topmenu._y + topmenu._height,
                           background.width - 10, background.height - topmenu.height - statusbar.height - 10, 5,
                           0x182a3d, 0x112233);
    
    if(current_mode == Mode_LifeNet ||
       current_mode == Mode_Expert) {
      if(current_mode == Mode_LifeNet) {
        set_status("current_mode = LifeNet");
      } else if(current_mode == Mode_Expert) {
        set_status("current_mode = Expert");
      }
        
      top_height = 16;
      left_width = 36;
        
      create_textfield(contents, "top_title", 0, 0, contents.width, top_height, 0xffffff, 14, "center");
      contents.top_title.text = slice_num + " Temporal Slices";
        
      create_textfield(contents, "left_user_know_title",
                       0, top_height+(contents.height-top_height)/3-5,
                       (contents.height-top_height)/3-10, left_width, 0xffffff, 14, "center");
      contents.left_user_know_title._rotation = -90;
      contents.left_user_know_title.text = "User\nKnowledge";
      contents.left_user_know_title.multiline = true;
       
      create_textfield(contents, "left_knowledge_title",
                       0, top_height+(contents.height-top_height)*2/3-5,
                       (contents.height-top_height)/3-10, left_width, 0xffffff, 14, "center");
      contents.left_knowledge_title._rotation = -90;
      if(current_mode == Mode_LifeNet) {
        contents.left_knowledge_title.text = "LifeNet\nKnowledge";
      } else if(current_mode == Mode_Expert) {
        contents.left_knowledge_title.text = "Expert\nKnowledge";
      }
      contents.left_knowledge_title.multiline = true;
        
      create_textfield(contents, "left_inference_title",
                       0, top_height+(contents.height-top_height)*3/3-5,
                       (contents.height-top_height)/3-10, left_width, 0xffffff, 14, "center");
      contents.left_inference_title._rotation = -90;
      if(current_mode == Mode_LifeNet) {
        contents.left_inference_title.text = "LifeNet\nInference";
      } else if(current_mode == Mode_Expert) {
        contents.left_inference_title.text = "Expert\nInference";
      }
      contents.left_inference_title.multiline = true;
      
      user_know = new Array(slice_num);
      knowledge = new Array(slice_num);
      inference = new Array(slice_num);
      
      for(index = 0; index < slice_num; index++) {
        // create knowledge boxes
        knowledge[index] = create_textrect(contents, "knowledge_"+index,
                                           left_width + index*(contents.width-left_width)/slice_num+5,
                                           top_height + (contents.height-top_height)/3+5,
                                           (contents.width-left_width)/slice_num-10, (contents.height-top_height)/3-10,
                                           5, 0x4488cc, 0xcccccc, 0x000000, 10, "center");
        knowledge[index].textfield.multiline = true;
        knowledge[index].textfield.size      = 10;
        
        // create inference boxes
        inference[index] = create_textrect(contents, "inference_"+index,
                                           left_width + index*(contents.width-left_width)/slice_num+5,
                                           top_height + (contents.height-top_height)*2/3+5,
                                           (contents.width-left_width)/slice_num-10, (contents.height-top_height)/3-10,
                                           5, 0x4488cc, 0xcccccc, 0x000000, 10, "center");
        inference[index].textfield.multiline = true;
        
        // create user knowledge boxes
        user_know[index] = create_textrect(contents, "user_know_"+index,
                                           left_width + index*(contents.width-left_width)/slice_num+5, top_height + 5,
                                           (contents.width-left_width)/slice_num-10, (contents.height-top_height)/3-10,
                                           5, 0x4488cc, 0xffffff, 0x000000, 10, "center");
        user_know[index].index     = index;
        user_know[index].test      = this;
        user_know[index].knowledge = knowledge[index];
        user_know[index].inference = inference[index];
        user_know[index].textfield.type      = "input";
        user_know[index].textfield.multiline = true;
        user_know[index].textfield.user_know = user_know[index];
        user_know[index].textfield.text = save_user_know[index];
        user_know[index].textfield.onChanged = function() {
          this.user_know.test.update_inference();
        };
      }
      update_inference();
    } else if(current_mode == Mode_Help) {
      set_status("current_mode = Help");
      create_textfield(contents, "textfield", 0, 0, contents.width, contents.height, 0xffffff, 14, "left");

      contents.textfield.text = "1.  Type simple phrases into the top "+
        "boxes (bright white \"User Knowledge\" boxes). These phrases are " +
        "immediately searched for within the Commonsense database for exact " +
        "word matches. These matches will be displayed in the middle row of " +
        "boxes labeled \"LifeNet Knowledge\". Multiple phrases can be added by " +
        "pressing [enter] to separate entries. Some possible phrases include " +
        "\"walk\", \"dog\", \"party\", \"wine\", \"baseball\", \"play\", \"drive\" or \"car\", " +
        "but try others also!\n" +

        "\n" +

        "2. After you entered a few phrases in a few of the \"User " +
        "Knowledge\" boxes, click the [Infer] button at the top of the " +
        "demonstration. This may take a while, but should return in the bottom " +
        "row labeled \"LifeNet Inference\" the probabilistically temporally " +
        "related commonsense assertions about what you have entered in step " +
        "one.\n";

      contents.textfield.wordWrap = true;

    } else {
      set_status("current_mode = undefined");
    }
  }
  
  public function destroy_contents_rect() {
    if(current_mode == Mode_LifeNet) {
    } else if(current_mode == Mode_Expert) {
    } else if(current_mode == Mode_Help) {
    }
    removeMovieClip(_root.contents);
  }

  public var Mode_LifeNet = 0;
  public var Mode_Expert  = 1;
  public var Mode_Help    = 2;
  public var current_mode = Mode_LifeNet;
  
  public function set_mode(mode:Number) {
    Trace("mode = " + mode + ", current_mode = " + current_mode);
    if(mode != current_mode) {
      destroy_contents_rect();
      current_mode = mode;
      create_contents_rect();
    }
  }
  
  public function set_slice_num(new_slice_num:Number) {
    slice_num = new_slice_num;
    save_user_know = new Array(slice_num);
    for(slice_index = 0; slice_index < slice_num; slice_index ++) {
      save_user_know[slice_index] = "";
    }
  }
  
  public function train_model() {
    set_status("Training Model");
    edges_str = "";
    for(index = 0; index < slice_num; index ++) {
      _train_edges_array = split_string(user_know[index].textfield.text, "\r");
      if(index+1 < slice_num) {
        _train_edges_array2 = split_string(user_know[index+1].textfield.text, "\r");
      }
      for(si0 = 0; si0 < _train_edges_array.length; si0 ++) {
        for(si1 = 0; si1 < _train_edges_array.length; si1 ++) {
          if(_train_edges_array[si0] != "" &&
             _train_edges_array[si1] != "") {
            edges_str += "(=> \""+_train_edges_array[si0]+"\" \""+_train_edges_array[si1]+"\" 0.1)";
          }
          if(index+1 < slice_num) {
            if(_train_edges_array[si0] != "" &&
               _train_edges_array2[si1] != "") {
              edges_str += "(-> \""+_train_edges_array[si1]+"\" \""+_train_edges_array2[si0]+"\" 0.1)";
            }
          }
        }
      }
    }
    
    set_status("train: "+edges_str);
    
    lifenet.add_edges(function() {
//_root.test.set_status("Training Model Complete");
    }, root_graph, edges_str);
  }
  
  public function Test(server:String) {
    
    Trace("in Test");
    
    drawfunc = new Draw.Functions;
    
    set_slice_num(3);
    
    var menu_button_num = 8;
    
    var background_width = Stage.width-2*10;
    var background_height = Stage.height-2*10;
    background = create_rect(_root, "background", 10, 10, background_width, background_height, 10, 0x99aabb, 0x224466);
    
    
    var topmenu_width  = background_width  - 4;
    var topmenu_height = 24;
    topmenu = create_rect(_root, "topmenu", background._x + 2, background._y + 2, topmenu_width, topmenu_height, 8, 0x336699, 0x4488cc);
    
    var topmenu_button        = new Array(menu_button_num);
    var topmenu_button_width  = new Array(menu_button_num);
    var topmenu_button_height = new Array(menu_button_num);
    var topmenu_button_text   = new Array(menu_button_num);
    var index;
    for(index = 0; index < menu_button_num; index ++) {
      topmenu_button_width[index]  = topmenu_width / menu_button_num - 4;
      topmenu_button_height[index] = topmenu_height - 4;
      topmenu_button[index]        = create_textrect(_root, "topmenu_button"+index,
                                                     topmenu._x + 2 + (topmenu_width * index / menu_button_num), topmenu._y + 2,
                                                     topmenu_button_width[index], topmenu_button_height[index],
                                                     8, 0x224455, 0x224466, 0xffffff, 14, "center");      
    }
    var statusbar_width  = background_width  - 4;
    var statusbar_height = 24;
    statusbar = create_textrect(_root, "statusbar",
                                background._x + 2, background_height - background._y - 6,
                                statusbar_width, statusbar_height,
                                8, 0x99aabb, 0xffffff, 0x000000, 14, "center");
    statusbar.textfield.align = "left";
    
    set_status("LifeNet Demo Loaded");
    
    topmenu_button[0].textfield.text = "LifeNet";
    topmenu_button[0].onPress = function() {
      set_status("LifeNet Pressed");
      _root.test.set_mode(_root.test.Mode_LifeNet);
    }
    
    removeMovieClip(topmenu_button[1]);
//    topmenu_button[1].textfield.text = "Expert";
//    topmenu_button[1].onPress = function() {
//      set_status("Expert Pressed");
//      _root.test.set_mode(_root.test.Mode_Expert);
//    }
    
    topmenu_button[2].textfield.text = "Clear";
    topmenu_button[2].onPress = function() {
      set_status("Clear Pressed");
      for(index = 0; index < _root.test.slice_num; index ++) {
        _root.test.user_know[index].textfield.text = "";
      }
      _root.test.update_inference();
    }
    
    topmenu_button[3].textfield.text = "Infer";
    topmenu_button[3].onPress = function() {
      set_status("Infer Pressed");
      _root.test.perform_inference();
    }
    
    removeMovieClip(topmenu_button[4]);
//    topmenu_button[4].textfield.text = "Train";
//    topmenu_button[4].onPress = function() {
//      set_status("Train Pressed");
//      _root.test.train_model();
//    }
    
    topmenu_button[menu_button_num-1].textfield.text = "Help";
    topmenu_button[menu_button_num-1].onPress = function() {
      _root.test.set_mode(_root.test.Mode_Help);
    }
    
    removeMovieClip(topmenu_button[5]);
    removeMovieClip(topmenu_button[6]);
    
    lifenet = new LifeNet.Connection("http://xnet.media.mit.edu:8056");
//    lifenet = new LifeNet.Connection("http://localhost:8056");
    
    set_status("Waiting for root graph ID from LifeNet server.");
    root_graph = lifenet.get_root_graph(
      function(root_graph_id) {
        _root.test.root_graph = root_graph_id;
        _root.test.set_status("Waiting for new default data ID from LifeNet server.");
        _root.test.lifenet.data_new(
          function(default_data_id) {
            _root.test.default_data = default_data_id;
            _root.test.set_status("Waiting for new knowledge data ID from LifeNet server.");
            _root.test.lifenet.data_new(
              function(knowledge_data_id) {
                _root.test.knowledge_data = knowledge_data_id;
                _root.test.set_status("Waiting for new inference data ID from LifeNet server.");
                _root.test.lifenet.data_new(
                  function(inference_data_id) {
                    _root.test.inference_data = inference_data_id;
                    _root.test.set_status("Waiting for LifeNet to perform default inference.");
                    _root.test.lifenet.infer(
                      function() {
                        _root.test.set_status("LifeNet loaded successfully.");
                        _root.test.create_contents_rect();
                      }, _root.test.root_graph, _root.test.knowledge_data, _root.test.default_data);
                  }, _root.test.slice_num);
              }, _root.test.slice_num);
          }, _root.test.slice_num);
      });
    
  }
  
  public function set_status(status:String) {
    _root.statusbar.textfield.text = status;
  }

}

	/*
	_root.createEmptyMovieClip("c", 1);
	_root.c.beginFill(0x00cc00, 100);
	_root.c.moveTo(0, 0); // make big rectangle
	_root.c.lineTo(100, 0);
	_root.c.lineTo(100, 70);
	_root.c.lineTo(0, 70);
	_root.c.lineTo(0, 0);
	_root.c.moveTo(80, 20); // cut out small rectangle
	_root.c.lineTo(50, 20);
	_root.c.lineTo(50, 40);
	_root.c.lineTo(80, 40);
	_root.c.lineTo(80, 20);
	_root.c.endFill();
	*/
	
/*
	var someshapes = _root.createEmptyMovieClip("someshapes", 2);
	with(someshapes) {
		lineStyle(2, 0x00ee00, 100); 
		beginFill(0x00cc00, 50);
		moveTo(50, 50);
		lineTo(200, 150);
		lineTo(80, 210);
		endFill();
		lineStyle(3, 0x00eeee, 30);
		beginFill(0x0000cc, 60);
		moveTo(180, 130);
		curveTo(200, 80, 250, 70);
		curveTo(200, 10, 40, 90);
		endFill();
	}
	*/
	
