﻿/*////////////////////////////////////////////////////////////////////////////////////////////// 
   XMLRPC.Connection Version 0.0.8 Alpha (for ActionScript 2.0)
   Last Modified: 04-21-2004
   First Modified: 01-20-2004
   
   :::::::::
    
   This is based on Patrick O'Lone's XML-RPC Flash Client, Version 0.6.1 Alpha for ActionScript 1.0
   Thank You Patrick!
   
   :::::::::
   
   Contact Information:
   Matt Shaw <matt@dopelogik.com>
   
   ORIGINAL CODE FROM:
   Patrick O'Lone <polone@aeonsolutions.com>
   http://www.sourceforge.net/projects/xmlrpcflash/

//////////////////////////////////////////////////////////////////////////////////////////////*/
import XMLRPC.*;

dynamic class XMLRPC.Connection {
	private var _VERSION:String = "0.0.6";
	private var _PRODUCT:String = "XMLRPC.Connection";
	private var _TRACE_LEVEL:Number = 3;
	private var MethodCall:Method;
	private var RPCResponseHandler:XML;
	private var RPCResponse;
	private var TransTTS:Date;
	private var TransTTL:Number;
	
	public var OnLoad:Function;
	
	/*
	XML.prototype.ERRORCODE 		= new Array();
	XML.prototype.ERRORCODE[0]  	= "Read ok but file was possibly not found.";
	XML.prototype.ERRORCODE[-1] 	= "Unknown Error Code.";
	XML.prototype.ERRORCODE[-2] 	= "A CDATA-Range was not closed correctly.";
	XML.prototype.ERRORCODE[-3] 	= "The XML-Declaration was not closed correctly.";
	XML.prototype.ERRORCODE[-4] 	= "The DOCTYPE-Declaration was not closed correctly.";
	XML.prototype.ERRORCODE[-5] 	= "A Comment was not closed correctly.";
	XML.prototype.ERRORCODE[-6] 	= "A XML-Element was not valid.";
	XML.prototype.ERRORCODE[-7] 	= "Out of Memory.";
	XML.prototype.ERRORCODE[-8] 	= "An Attributevalue was not closed correctly.";
	XML.prototype.ERRORCODE[-9] 	= "No starting Tag found for an ending Tag.";
	XML.prototype.ERRORCODE[-10] 	= "No ending Tag found for an starting Tag.";
	*/	
	
	/*///////////////////////////////////////////////////////
	Constructor()
	?:	Constructor!
	IN:	RPC Server URL, Desired timeout
	OUT:	Instance of object
 	///////////////////////////////////////////////////////*/
	public function Connection(server:String, timeout:Number) {
		//prepare method response handler
		this.RPCResponseHandler = new XML();
		this.RPCResponseHandler.ignoreWhite = true;
		this.RPCResponseHandler["ref"] = this;
		
		//init method object
		this.MethodCall = new Method();
		this.MethodCall.Server = server;
		
		this.TransTTS = null;
		this.TransTTL = timeout;
		
		this.InitRTrace();
		
		RTrace("Object instance created. (v" + _VERSION + ")",1);
	}
	
	/*///////////////////////////////////////////////////////
	Call()
	?:	Calls a method to RPC server
	IN:	Method Name
	OUT:	Boolean-Not sure why right now.
 	///////////////////////////////////////////////////////*/
	public function Call(method:String):Boolean {
		RTrace("Call("+method+")",2);

		//Clear any old responses
		this.RPCResponse = null;
		
		//hook-up built-in onLoad
		this.RPCResponseHandler.onLoad = this._OnLoad;
		
		//Trigger method call
		this.MethodCall.Call(method, this.RPCResponseHandler);
		this.TransTTS = new Date();

		return true; //all went good
	}
	
	/*///////////////////////////////////////////////////////
	AddParameter()
	?:	Wrapper for Method.AddParameter()
 	///////////////////////////////////////////////////////*/
	public function AddParameter(paramType:String, paramValue:Object):Boolean {
		RTrace("AddParameter()",2);
		return this.MethodCall.AddParameter(paramType, paramValue);
	}
	
	/*///////////////////////////////////////////////////////
	ClearParameters()
	?:	Wrapper for Method.ClearParameters()
 	///////////////////////////////////////////////////////*/
	public function ClearParameters():Void{
		this.MethodCall.ClearParameters()
	}
	
	/*//////////////////////////////////////////////////////////////////////
	Parse()
	?:	Parses XML node, via RPC spec
	IN:	XML Node from RPC Response
	OUT:	Returns UnMarshalled Object;		
	NOTE: Pat, I thought the RPC_Object defeated the  purpose 
		 of RPC. If the RPC returns an array, marhsalls it to
		 XML, then sends to Flash - Flash should unmarshall it
		 into an array, not a complicated RPC_Object. 
		 So until i figure out why you did that, R.I.P RPC_Object
 	//////////////////////////////////////////////////////////////////////*/
	private function Parse(Node:XMLNode):Object {
		//RTrace("XMLRPC -> Parse()");
		var Data:Object;
		if (Node.nodeType == 3) {
			return Node.nodeValue;
		}
		if (Node.nodeType == 1) {
			if ((Node.nodeName == "methodResponse") || (Node.nodeName == "value") || (Node.nodeName == "param") || (Node.nodeName == "fault") || (Node.nodeName == "params") || (Node.nodeName == "array")  || (Node.nodeName == "array")) {
				RTrace("Parse(): >> " + Node.nodeName,3);
				return this.Parse(Node.firstChild);
			}
			
			if (Node.nodeName == "data") {
				RTrace("Parse(): >> Begin Array",3);
				Data = [];
				for (var i=0; i<Node.childNodes.length;i++) {
					Data.push(this.Parse(Node.childNodes[i]));
					RTrace("Parse(): adding data to array: "+Data[Data.length-1]);
				}
				RTrace("Parse(): << End Array",3);
				return Data;
			}
			
			if (Node.nodeName == "struct") {
				RTrace("Parse(): >> Begin Struct",3);
				Data = {};
				for (var i=0; i<Node.childNodes.length;i++) {
					var Temp = this.Parse(Node.childNodes[i]);
					Data[Temp.name]=Temp.value;
					RTrace("Parse(): Struct  item "+Temp.name + ":" + Temp.value,3);
				}
				RTrace("Parse(): << End Stuct",3);
				return Data;
			}
			
			// The member tag is *special*. The returned
			// value is *always* a hash (or in Flash-speak,
			// it is always an Object).
			if (Node.nodeName == "member") {
				var Temp1;
				var Temp2;
				var Data = {};
				Temp1 = this.Parse(Node.firstChild);
				Temp2 = this.Parse(Node.lastChild);
				Data.name = Temp1;
				Data.value = Temp2;

				
				return Data;
			}
			if (Node.nodeName == "name") {
				var Data = new RPCObject();
				return this.Parse(Node.firstChild);
			}
			
			// These are the simple object data types.
			// we just want the values returned.
			if ((Node.nodeName == "string") || (Node.nodeName == "int") || (Node.nodeName == "i4") || (Node.nodeName == "base64") || (Node.nodeName == "boolean") || (Node.nodeName == "double") || (Node.nodeName == "dateTime.iso8601")) {
				return  Node.firstChild.nodeValue;
				//Data = new RPCObject(Node.nodeName);
				//Data.SetValue(this.Parse(Node.firstChild));
			}
		}
		return false;
	}

	/*///////////////////////////////////////////////////////////////////////
	UnMarshall()
	?: 	A slight wrapper for Parse()
	IN:    Void
	OUT: A Variable, depending RPCMethod return type
	///////////////////////////////////////////////////////////////////////*/
	private function UnMarshall() {
		RTrace("UnMarshall()",2);
		RTrace("MethodResponse:" + this.RPCResponseHandler.toString(),3);
		if (this.IsLoaded()) {
			if (this.RPCResponseHandler.status == 0) {
				RTrace("UnMarshall(): Ready to parse response.",3);
				if (this.RPCResponse == null) {
					this.RPCResponse = this.Parse(this.RPCResponseHandler.firstChild);
				}
				RTrace("UnMarshall(): Finished Parsing",3);
				return this.RPCResponse;
			}
			RTrace("UnMarshall(): Parsing error: "+this.RPCResponseHandler.status,1);
			return null;
		}
		RTrace("UnMarshall(): The RPCResponseHandler object has not yet loaded.",3);
		return null;
	}
	

	/*///////////////////////////////////////////////////////////////////////
	OnLoaded()
	?: 	Private onLoad for XML. Then triggers user OnLoad.
	IN: 	Boolean
	OUT: Void
	///////////////////////////////////////////////////////////////////////*/
	private function _OnLoad(success:Boolean):Void {
		this.ref.RTrace("_OnLoad()",1);
		if (success) {
			var a = this.ref.UnMarshall();
			this.ref.OnLoad(a);
			this.CleanUp();
		} else {
			//this.ref.onFailed(this.ERRORCODE[this.status]);
			this.ref.onFailed(this.status);
		}
	}
	

	/*///////////////////////////////////////////////////////////////////////
	IsLoaded()
	?: 	Finds out if XML is loaded from RPC server
	IN: 	Void
	OUT: Boolean
	///////////////////////////////////////////////////////////////////////*/
	public function IsLoaded():Boolean {
		RTrace("IsLoaded()",3);
		return this.RPCResponseHandler.loaded;
	}
	
	/*///////////////////////////////////////////////////////////////////////
	HasTimedOut()
	?: 	Finds out if XML connection to RPC server has timed out
	IN: 	Void
	OUT: Boolean
	///////////////////////////////////////////////////////////////////////*/
	public function HasTimedOut():Boolean {
		RTrace("HasTimedOut()",3);
		var Now = new Date();
		//trace("Time: "+this.TransTTS.getTime());
		//trace("Now:  "+Now.getTime());
		if ((this.TransTTS.getTime()+1000*this.TransTTL)<Now.getTime()) {
			return true;
		}
		return false;
	}
	
	/*///////////////////////////////////////////////////////////////////////
	Server : getter/setter 
	///////////////////////////////////////////////////////////////////////*/
	public function get Server(){
		return this.MethodCall.Server;
	}
	public function set Server(a){
		this.MethodCall.Server = a;
	}
	
	
	/*///////////////////////////////////////////////////////////////////////
	CleanUp()
	?: 	
	///////////////////////////////////////////////////////////////////////*/
	public function CleanUp(a):Void {
		this.RPCResponseHandler.parseXML(null);
		this.MethodCall.CleanUp();
		this.RPCResponse=null;
	}
	
	////////////////////////////////////////////////////////////////////////////////////////////
	//														//
	//	RemoteTrace Methods  (Uses Optional RemoteTrace Tool)			//
	//														//
	//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~//
		private var RTracer:Object;
		/*///////////////////////////////////////////////////////////////////////
		InitRTrace()
		?: 	Inits RTrace Object
		///////////////////////////////////////////////////////////////////////*/
		private function InitRTrace():Void {
			if (typeof(RemoteTrace)=="function"){
				this.RTracer = new RemoteTrace("XMLRPC");
				this.RTracer.TraveLevel = this._TRACE_LEVEL;
			} else {
				trace("RemoteTrace not found, tracing to output");
			}
		}
		
		/*///////////////////////////////////////////////////////////////////////
		RTrace()
		?: 	traces to Output and (If available) the RemoteTrace Tool for debugging
		IN: 	A message, level of verboseness (higher=more)
		OUT: Void
		///////////////////////////////////////////////////////////////////////*/
		private function RTrace(a,traceLevel:Number):Void {
			var traceFunc = this.RTracer.trace;
			if (traceFunc==undefined) traceFunc = trace;
			traceFunc(this._PRODUCT + " -> " + a, traceLevel);
		}
	//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~//
	//														//
	//	End RemoteTrace Methods									//
	//														//
	////////////////////////////////////////////////////////////////////////////////////////////
}

	/*
	EXAMPLES
	<?xml version='1.0'?>
	<methodResponse>
		<params>
			<param>
				<value>
					<array>
						<data>
							<value>
								<string>CaseStudy.2004-01-19.5433633610</string>
							</value>
							<value>
								<string>CaseStudy.2004-01-27.4198073648</string>
							</value>
						</data>
					</array>
				</value>
			</param>
		</params>
	</methodResponse>
	
	<?xml version='1.0'?>
	<methodResponse>
		<fault>
			<value>
				<struct>
					<member>
						<name>faultCode</name>
						<value>
							<int>-2</int>
						</value>
					</member>
					<member>
						<name>args</name>
						<value>
							<array>
								<data />
							</array>
						</value>
					</member>
					<member>
						<name>faultString</name>
						<value>
							<string>Unexpected Zope error value: </string>
						</value>
					</member>
				</struct>
			</value>
		</fault>
	</methodResponse>
*/
