﻿/*////////////////////////////////////////////////////////////////////////////////////////////// 
   XMLRPC.Method Version 0.0.2 Alpha (for ActionScript 2.0)
   Last Modified: 04-21-2004
   First Modified: 01-30-2004
   
   :::::::::
    
   This is based on Patrick O'Lone's XML-RPC Flash Client, Version 0.6.1 Alpha for ActionScript 1.0
   Thank You Patrick!
   
   :::::::::
   
   Contact Information:
   Matt Shaw <matt@dopelogik.com>
   
   ORIGINAL CODE FROM:
   Patrick O'Lone <polone@aeonsolutions.com>
   http://www.sourceforge.net/projects/xmlrpcflash/

//////////////////////////////////////////////////////////////////////////////////////////////*/
dynamic class XMLRPC.Method {
	private var _VERSION:String = "0.0.2";
	private var _PRODUCT:String = "XMLRPC.Method";
	private var _TRACE_LEVEL:Number = 3;
	
	private var methodCall:XML;
	private var Parameters:Array;
	private var methodName:String
	
	public var Server:String;
	
	/*///////////////////////////////////////////////////////
	Constructor
	///////////////////////////////////////////////////////*/
	public function Method(){
		this.Parameters = new Array();
		this.methodCall = new XML();
		this.methodCall.xmlDecl = "<?xml version=\"1.0\"?>";
		this.methodCall.contentType = "text/xml";
		InitRTrace();
		RTrace("Object instance created. (v" + _VERSION + ")",1);
	}
	
	/*///////////////////////////////////////////////////////
	Call()
	?:	Calls a method to RPC server
	IN:	Method Name
	OUT:	Boolean-Not sure why right now.
 	///////////////////////////////////////////////////////*/
	public function Call(method:String, responseHandler:XML):Boolean {
		RTrace("Call("+method+") -> " + this.Server,1);
		this.methodName = method;
		this.Render();
		this.methodCall.sendAndLoad(this.Server, responseHandler);
		RTrace("Call("+method+") -> Request Sent.",1);
		return true;
	}
	
	/*///////////////////////////////////////////////////////
	Render()
	?:	
	IN:	
	OUT:	
 	///////////////////////////////////////////////////////*/
	public function Render():Boolean {
		RTrace("Render()",1);
		var ParentNode:XMLNode = new XMLNode();
		var ChildNode:XMLNode = new XMLNode();
		
		// Create the <methodCall>...</methodCall> root node
		ParentNode = this.methodCall.createElement("methodCall");
		this.methodCall.appendChild(ParentNode);
		
		// Create the <methodName>...</methodName> node
		ChildNode = this.methodCall.createElement("methodName");
		ChildNode.appendChild(this.methodCall.createTextNode(this.methodName));
		ParentNode.appendChild(ChildNode);
		
		// Create the <params>...</params> node
		ChildNode = this.methodCall.createElement("params");
		ParentNode.appendChild(ChildNode);
		ParentNode = ChildNode;
		
		// build nodes that hold all the params
		RTrace("Render(): Creating the params node.",2);
		for (var i =0; i<this.Parameters.length;i++) {
			RTrace("PARAM: " + this.Parameters[i]);
			ChildNode = this.methodCall.createElement("param");
			ChildNode.appendChild(this.CreateNode(this.Parameters[i]));
			ParentNode.appendChild(ChildNode);
		}
		RTrace("Render(): Resulting XML document:",2);
		RTrace("Render(): "+this.methodCall.toString(),2);
		
		return true;
	}
	
		
	/*///////////////////////////////////////////////////////////////////////
	CreateNode()
	?: 	This method creates <value>...</value> tag pairs with the 
		correct data types for each value. This method is recursively
		called for each <struct> and <array> that is defined.
	IN:    A Parameter (?)
	OUT: A node representing the entire <params> tree 
	///////////////////////////////////////////////////////////////////////*/		   
	private function CreateNode(Parameter):XMLNode {
		RTrace("CreateNode()",2);
		var Node:XMLNode = this.methodCall.createElement("value");
		var TypeNode:XMLNode;

		if (typeof (Parameter) == "object") {
			// Handle Explicit Simple Objects
			if ((Parameter.type == "base64") || (Parameter.type == "int") || (Parameter.type == "i4") || (Parameter.type == "string") || (Parameter.type == "double") || (Parameter.type == "datetime.iso8601") || (Parameter.type == "boolean")) {
				RTrace("CreateNode(): Creating object '"+Parameter.value+"' as type "+Parameter.type,3);
				TypeNode = this.methodCall.createElement(Parameter.type);
				TypeNode.appendChild(this.methodCall.createTextNode(Parameter.value));
				Node.appendChild(TypeNode);
				return Node;
			}
			// Handle Array Objects
			if (Parameter.type == "array") {
				var DataNode;
				RTrace("CreateNode(): >> Begin Array",3);
				TypeNode = this.methodCall.createElement("array");
				DataNode = this.methodCall.createElement("data");
				for (var i in Parameter.value) {
					DataNode.appendChild(this.CreateNode(Parameter.value[i]));
				}
				TypeNode.appendChild(DataNode);
				RTrace("CreateNode(): << End Array",3);
				Node.appendChild(TypeNode);
				return Node;
			}
			// Handle Struct Objects
			if (Parameter.type == "struct") {
				RTrace("CreateNode(): >> Begin struct",3);
				TypeNode = this.methodCall.createElement("struct");
				for (var i in Parameter.value) {
					var MemberNode = this.methodCall.createElement("member");

					// add name node
					MemberNode.appendChild(this.methodCall.createElement("name"));
					MemberNode.lastChild.appendChild(this.methodCall.createTextNode(i));

					// add value node
					MemberNode.appendChild(this.methodCall.createElement("value"));
					MemberNode.lastChild.appendChild(this.methodCall.createTextNode(Parameter.value[i]));
					
					//depreciated?
					/*if (Parameter.value[i].type == null) {
						MemberNode.appendChild(this.CreateNode(Parameter.value[i].value));
					} else {
						MemberNode.appendChild(this.CreateNode(Parameter.value[i]));
					}
					*/
					TypeNode.appendChild(MemberNode);
				}
				RTrace("CreateNode(): << End struct",3);
				Node.appendChild(TypeNode);
				return Node;
			}
		}
	}
	
	/*///////////////////////////////////////////////////////
	AddParameter()
	?:	Adds a parameter aka argument for the method called
	IN:	Object holding type and value, not sure I like it one variable-
		not good for self documenting code.
	OUT:	Boolean-Not sure why right now.
 	///////////////////////////////////////////////////////*/
	public function AddParameter(paramType:String, paramValue:Object):Boolean {
		RTrace("AddParameter()",2);
		this.Parameters.push({type:paramType,value:paramValue});
		return true;
	}
	
	/*///////////////////////////////////////////////////////
	ClearParameters()
	?:	Clears Parameters
	IN:	Void
	OUT:	Void
 	///////////////////////////////////////////////////////*/
	public function ClearParameters():Void{
		this.Parameters=[];
	}

	/*///////////////////////////////////////////////////////////////////////
	CleanUp()
	?: 	traces to Output and (If available) the RemoteTrace Tool for debugging
	IN: 	A message
	OUT: Void
	///////////////////////////////////////////////////////////////////////*/
	public function CleanUp():Void {
		this.ClearParameters();
		this.methodCall.parseXML(null);
	}
	
	////////////////////////////////////////////////////////////////////////////////////////////
	//														//
	//	RemoteTrace Methods  (Uses Optional RemoteTrace Tool)			//
	//														//
	//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~//
		private var RTracer:Object;
		/*///////////////////////////////////////////////////////////////////////
		InitRTrace()
		?: 	Inits RTrace Object
		///////////////////////////////////////////////////////////////////////*/
		private function InitRTrace():Void {
			if (typeof(RemoteTrace)=="function"){
				this.RTracer = new RemoteTrace("XMLRPC");
				this.RTracer.TraveLevel = this._TRACE_LEVEL;
			} else {
				trace("RemoteTrace not found, tracing to output");
			}
		}
		
		/*///////////////////////////////////////////////////////////////////////
		RTrace()
		?: 	traces to Output and (If available) the RemoteTrace Tool for debugging
		IN: 	A message, level of verboseness (higher=more)
		OUT: Void
		///////////////////////////////////////////////////////////////////////*/
		private function RTrace(a,traceLevel:Number):Void {
			var traceFunc = this.RTracer.trace;
			//if (traceFunc==undefined) 
			traceFunc = trace;
			traceFunc(this._PRODUCT + " -> " + a, traceLevel);
		}
	//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~//
	//														//
	//	End RemoteTrace Methods									//
	//														//
	////////////////////////////////////////////////////////////////////////////////////////////
	
}